"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OpAdd = void 0;
var tslib_1 = require("tslib");
var AbstractOp_1 = require("./AbstractOp");
var json_pointer_1 = require("../../json-pointer");
var OpAdd = (function (_super) {
    tslib_1.__extends(OpAdd, _super);
    function OpAdd(path, value) {
        var _this = _super.call(this, 'add', path) || this;
        _this.value = value;
        return _this;
    }
    OpAdd.prototype.apply = function (doc) {
        var ref = json_pointer_1.find(doc, this.path);
        if (json_pointer_1.isObjectReference(ref))
            ref.obj[ref.key] = this.value;
        else if (json_pointer_1.isArrayReference(ref)) {
            if (ref.key > ref.obj.length)
                throw new Error('OUT_OF_BOUNDS');
            if (ref.key === ref.obj.length)
                ref.obj.push(this.value);
            else
                ref.obj.splice(ref.key, 0, this.value);
        }
        else
            doc = this.value;
        return { doc: doc, old: ref.val };
    };
    OpAdd.prototype.toJson = function () {
        return {
            op: this.op,
            path: json_pointer_1.formatJsonPointer(this.path),
            value: this.value,
        };
    };
    OpAdd.prototype.toPacked = function () {
        return [0, this.path, { v: this.value }];
    };
    return OpAdd;
}(AbstractOp_1.AbstractOp));
exports.OpAdd = OpAdd;
