"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyPatch = exports.applyOps = exports.applyOp = void 0;
var tslib_1 = require("tslib");
var util_1 = require("./util");
var op_1 = require("./op");
function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = util_1.deepClone(doc);
    return op.apply(doc);
}
exports.applyOp = applyOp;
function applyOps(doc, ops, mutate) {
    var e_1, _a;
    if (!Array.isArray(ops))
        throw new Error('SEQUENCE_NOT_AN_ARRAY');
    if (!mutate)
        doc = util_1.deepClone(doc);
    var res = [];
    try {
        for (var ops_1 = tslib_1.__values(ops), ops_1_1 = ops_1.next(); !ops_1_1.done; ops_1_1 = ops_1.next()) {
            var op = ops_1_1.value;
            var opResult = op.apply(doc);
            doc = opResult.doc;
            res.push(opResult);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (ops_1_1 && !ops_1_1.done && (_a = ops_1.return)) _a.call(ops_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return { doc: doc, res: res };
}
exports.applyOps = applyOps;
function applyPatch(doc, patch, mutate) {
    var result = applyOps(doc, patch.map(op_1.operationToOp), mutate);
    return result;
}
exports.applyPatch = applyPatch;
