"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isElementNode = exports.isTextNode = exports.deepClone = void 0;
function deepClone(obj) {
    switch (typeof obj) {
        case 'object':
            return JSON.parse(JSON.stringify(obj));
        case 'undefined':
            return null;
        default:
            return obj;
    }
}
exports.deepClone = deepClone;
var isArray = Array.isArray;
exports.isTextNode = function (node) {
    return !!node && typeof node === 'object' && typeof node.text === 'string';
};
exports.isElementNode = function (node) {
    return !!node && typeof node === 'object' && isArray(node.children);
};
