"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isObjectReference = exports.isArrayEnd = exports.isArrayReference = exports.find = void 0;
var util_1 = require("./util");
var isArray = Array.isArray;
exports.find = function (val, path, skipLast) {
    if (skipLast === void 0) { skipLast = 0; }
    if (util_1.isRoot(path))
        return { val: val };
    var obj;
    var key;
    var last = path.length - 1 - skipLast;
    for (var i = 0; i <= last; i++) {
        var component = path[i];
        obj = val;
        key = component;
        if (isArray(obj)) {
            if (key === '-' && i === path.length - 1)
                key = obj.length;
            else {
                if (!util_1.isValidIndex(key))
                    throw new Error('INVALID_INDEX');
                key = Number(key);
                if (key < 0)
                    throw new Error('INVALID_INDEX');
            }
            val = util_1.hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else if (typeof obj === 'object' && !!obj) {
            val = util_1.hasOwnProperty(obj, String(key)) ? obj[key] : undefined;
        }
        else
            throw new Error('NOT_FOUND');
    }
    var ref = { val: val, obj: obj, key: key };
    return ref;
};
exports.isArrayReference = function (ref) {
    return isArray(ref.obj) && typeof ref.key === 'number';
};
exports.isArrayEnd = function (ref) { return ref.obj.length === ref.key; };
exports.isObjectReference = function (ref) {
    return typeof ref.obj === 'object' && typeof ref.key === 'string';
};
