"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.microtask = exports.assertName = exports.assertId = exports.isArray = void 0;
exports.isArray = Array.isArray;
exports.assertId = function (id) {
    if (typeof id !== 'number' || id < 1 || Math.round(id) !== id)
        throw new Error('Invalid ID.');
};
exports.assertName = function (name) {
    if (typeof name !== 'string' || !name || name.length > 128)
        throw new Error('Invalid method.');
};
var nextTickMicrotask = typeof process === 'object' && typeof process.nextTick === 'function' ? process.nextTick : null;
var promiseMicrotask = function (callback) {
    Promise.resolve().then(callback);
};
exports.microtask = nextTickMicrotask || promiseMicrotask;
